/*==========================================================================
 *
 *  Copyright (C) 2001 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act.cpp
 *  Content	:ANg֘A
 *  Program	:J.Issiki
 *  Date	:2001/6/24
 *  UpDate	:2004/3/18
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static POOL ActPool = { sizeof(ACT) };

void
ACTinit()
{
	int cnt;

	/* ANgO[vǗe[ȕ */
	for(cnt = 0; cnt < ACT_GROUP_MAX; cnt++) {
		ActIndex[cnt][ACT_TOP].prev_act = NULL;
		ActIndex[cnt][ACT_TOP].next_act = &ActIndex[cnt][ACT_BOTTOM];
		ActIndex[cnt][ACT_BOTTOM].prev_act = &ActIndex[cnt][ACT_TOP];
		ActIndex[cnt][ACT_BOTTOM].next_act = NULL;
	}
}

ACT*
ACTsetTop(FUNC exec_adr, int act_cnt)
{
	ACT* actp;

	/* 󂫃ANg擾 */
	actp = pool_alloc(&ActPool);

	/* ̃o̒lݒ */
	actp->prog_adr = exec_adr;

	/* ANgO[vɓo^ */
	actp->prev_act = &ActIndex[act_cnt][ACT_TOP];
	actp->next_act = ActIndex[act_cnt][ACT_TOP].next_act;
	actp->prev_act->next_act = actp;
	actp->next_act->prev_act = actp;

	return actp;
}

ACT*
ACTsetBtm(FUNC exec_adr, int act_cnt)
{
	ACT* actp;

	/* 󂫃ANg擾 */
	actp = pool_alloc(&ActPool);

	/* ̃o̒lݒ */
	actp->prog_adr = exec_adr;

	/* ANgO[vɓo^ */
	actp->prev_act = ActIndex[act_cnt][ACT_BOTTOM].prev_act;
	actp->next_act = &ActIndex[act_cnt][ACT_BOTTOM];
	actp->prev_act->next_act = actp;
	actp->next_act->prev_act = actp;

	return actp;
}

void
ACTexec()
{
	ACT* actp;
	int cnt;

	for(cnt = 0; cnt < ACT_GROUP_MAX; cnt++) {
		for(actp = ActIndex[cnt][ACT_TOP].next_act;
		    actp != &ActIndex[cnt][ACT_BOTTOM];
		    actp = actp->next_act) {
			actp->prog_adr(actp);
		}
	}
}

void
ACTclearAll(ACT* actp)
{
	ACT* eactp;
	int cnt;

	for(cnt = 0; cnt < ACT_GROUP_MAX; cnt++) {
		for(eactp = ActIndex[cnt][ACT_TOP].next_act;
		    eactp != &ActIndex[cnt][ACT_BOTTOM];
		    eactp = eactp->next_act) {
			if(actp != eactp) {
				ACTclear(eactp);
			}
		}
	}
}

void
ACTclear(ACT* actp)
{
	BulletMLdelCtrl(actp);

	/* ANgO[v؂藣 */
	actp->next_act->prev_act = actp->prev_act;
	actp->prev_act->next_act = actp->next_act;

	/* ANg󂫃XgɃN */
	pool_free(actp);
}

