
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
	.global	ppu_grayscale_table
	.code
	.align	2
ppu_grayscale_table:
	.byte	21
	.byte	33
	.byte	37
	.byte	36
	.byte	32
	.byte	31
	.byte	32
	.byte	33
	.byte	33
	.byte	35
	.byte	35
	.byte	34
	.byte	34
	.byte	42
	.byte	41
	.byte	41
	.byte	9
	.byte	26
	.byte	27
	.byte	26
	.byte	23
	.byte	24
	.byte	26
	.byte	27
	.byte	23
	.byte	27
	.byte	28
	.byte	27
	.byte	23
	.byte	37
	.byte	41
	.byte	41
	.byte	0
	.byte	16
	.byte	16
	.byte	14
	.byte	18
	.byte	17
	.byte	15
	.byte	14
	.byte	11
	.byte	12
	.byte	16
	.byte	15
	.byte	13
	.byte	27
	.byte	40
	.byte	40
	.byte	0
	.byte	5
	.byte	6
	.byte	10
	.byte	9
	.byte	10
	.byte	6
	.byte	3
	.byte	3
	.byte	6
	.byte	8
	.byte	7
	.byte	5
	.byte	6
	.byte	39
	.byte	39
	.code
	.align	1
	.global	ppu_reset
ppu_reset:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ld.w	%r0,%r12
	ext	ppu+0x0@h	; 	xld.w	%r12,ppu
	ext	ppu+0x0@m
	ld.w	%r12,ppu+0x0@l
	ld.w	%r13,0x0
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	ext	ppu+0x8@ah	; 	xld.b	[ppu+8],%r0
	ext	ppu+0x8@al
	ld.b	[%r8],%r0
	popn	%r0
	ret
	.align	1
	.global	ppu_read
ppu_read:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@h	; 	xld.w	%r13,ppu
	ext	ppu+0x0@m
	ld.w	%r13,ppu+0x0@l
	and	%r12,0x7	; 	xand	%r12,%r12,0x00000007
	cmp	%r12,0x2	; 	xcmp	%r12,2
	jreq	__LX65		; 	xjreq	__L65
	cmp	%r12,0x7	; 	xcmp	%r12,7
	jreq	__LX66		; 	xjreq	__L66
	jp	__LX69		; 	xjp	__L69
__LX65:				; __L65:
	ext	ppu+0x2@ah	; 	xld.ub	%r12,[ppu+2]
	ext	ppu+0x2@al
	ld.ub	%r12,[%r8]
	jp	__LX64		; 	xjp	__L64
__LX66:				; __L66:
	ext	ppu+0x9@ah	; 	xld.ub	%r12,[ppu+9]
	ext	ppu+0x9@al
	ld.ub	%r12,[%r8]
	ext	ppu+0x6@ah	; 	xld.uh	%r11,[ppu+6]
	ext	ppu+0x6@al
	ld.uh	%r11,[%r8]
	ld.w	%r10,%r11
	ext	0xff		; 	xand	%r10,%r10,0x00003fff
	and	%r10,0x3f
	ext	ppu_vram+0x0@h	; 	xld.ub	%r10,[%r10+ppu_vram]
	ext	ppu_vram+0x0@m
	ld.w	%r9,ppu_vram+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ext	ppu+0x9@ah	; 	xld.b	[ppu+9],%r10
	ext	ppu+0x9@al
	ld.b	[%r8],%r10
	ld.uh	%r11,%r11
	btst	[%r13],0x2	; 	xbtst	[%r13],0x2
	jreq	__LX67		; 	xjreq	__L67
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX68		; 	xjp	__L68
__LX67:				; __L67:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX68:				; __L68:
	ext	0x6		; 	xld.h	[%r13+6],%r10
	ld.h	[%r13],%r10
	jp	__LX64		; 	xjp	__L64
__LX69:				; __L69:
	ld.w	%r12,0x0
__LX64:				; __L64:
	ld.w	%r10,%r12
	ret
	.align	1
	.global	ppu_write
ppu_write:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ext	ppu+0x0@h	; 	xld.w	%r0,ppu
	ext	ppu+0x0@m
	ld.w	%r0,ppu+0x0@l
	ld.w	%r10,%r12
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	cmp	%r10,0x7	; 	xcmp	%r10,7
	jrugt	__L72		; 	xjrugt	__L72
	sll	%r10,0x2	; 	xsll	%r10,2
	ext	__L82+0x0@h	; 	xld.w	%r10,[%r10+__L82]
	ext	__L82+0x0@m
	ld.w	%r9,__L82+0x0@l
	add	%r9,%r10
	ld.w	%r10,[%r9]
	jp	%r10
	.code
	.align	2
__L82:
	.word	__L73
	.word	__L74
	.word	__L72
	.word	__L75
	.word	__L76
	.word	__L77
	.word	__L78
	.word	__L79
	.code
__L73:
	ld.b	[%r0],%r13	; 	xld.b	[%r0],%r13
	jp	__L72		; 	xjp	__L72
__L74:
	ext	0x1		; 	xld.b	[%r0+1],%r13
	ld.b	[%r0],%r13
	jp	__L72		; 	xjp	__L72
__L75:
	ext	0x3		; 	xld.b	[%r0+3],%r13
	ld.b	[%r0],%r13
	jp	__L72		; 	xjp	__L72
__L76:
	ext	0x3		; 	xld.ub	%r10,[%r0+3]
	ld.ub	%r10,[%r0]
	ext	0x1		; 	xadd	%r11,%r10,1
	add	%r11,%r10
	ext	0x3		; 	xld.b	[%r0+3],%r11
	ld.b	[%r0],%r11
	ld.ub	%r10,%r10
	ext	ppu_sprram+0x0@h	; 	xld.b	[%r10+ppu_sprram],%r13
	ext	ppu_sprram+0x0@m
	ld.w	%r9,ppu_sprram+0x0@l
	add	%r9,%r10
	ld.b	[%r9],%r13
	jp	__L72		; 	xjp	__L72
__L77:
	ext	0x4		; 	xld.uh	%r10,[%r0+4]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	ext	0x4		; 	xld.h	[%r0+4],%r10
	ld.h	[%r0],%r10
	jp	__L72		; 	xjp	__L72
__L78:
	ext	0x6		; 	xld.uh	%r10,[%r0+6]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	jp	__LX81		; 	xjp	__L81
__L79:
	ext	0x6		; 	xld.uh	%r12,[%r0+6]
	ld.uh	%r12,[%r0]
	ext	0xff		; 	xand	%r12,%r12,0x00003fff
	and	%r12,0x3f
	ext	ppu_vram_write@rm	; 	xcall	ppu_vram_write
	call	ppu_vram_write@rl
	ext	0x6		; 	xld.uh	%r11,[%r0+6]
	ld.uh	%r11,[%r0]
	btst	[%r0],0x2	; 	xbtst	[%r0],0x2
	jreq	__LX80		; 	xjreq	__L80
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX81		; 	xjp	__L81
__LX80:				; __L80:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX81:				; __L81:
	ext	0x6		; 	xld.h	[%r0+6],%r10
	ld.h	[%r0],%r10
__L72:
	popn	%r0
	ret
	.align	1
	.global	ppu_update
ppu_update:
;	.frame	%sp,20,$31		# vars= 4, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r15,%r12
	ext	ppu+0x0@h	; 	xld.w	%r2,ppu
	ext	ppu+0x0@m
	ld.w	%r2,ppu+0x0@l
	ext	ppu_vram+0x0@h	; 	xld.w	%r10,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r10,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r14,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r14,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	cmp	%r15,0x0
	jreq	__LX85		; 	xjreq	__L85
	cmp	%r1,0x0
	jreq	__LX85		; 	xjreq	__L85
	ext	ppu+0xc@ah	; 	xld.w	[ppu+12],%r15
	ext	ppu+0xc@al
	ld.w	[%r8],%r15
	ext	0x1		; 	xadd	%r12,%r10,16128
	ext	0x1f00
	add	%r12,%r10
	ext	0x10		; 	xadd	%r11,%r2,16
	add	%r11,%r2
	ext	0x0		; 	xld.w	%r0,0x00000020		; 32
	ld.w	%r0,0x20
	ext	0x0		; 	xld.w	%r13,0x0000003f		; 63
	ld.w	%r13,0x3f
__LX86:				; __L86:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,%r13
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	ext	ppu_grayscale_table+0x0@h	; 	xld.ub	%r10,[%r10+ppu_grayscale_table]
	ext	ppu_grayscale_table+0x0@m
	ld.w	%r9,ppu_grayscale_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	add	%r11,0x1	; 	xadd	%r11,%r11,1
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX86		; 	xjrne	__L86
	ld.w	%r12,%r14
	sll	%r12,0x8	; 	xsll	%r12,8
	ext	0x10		; 	xld.ub	%r13,[%r2+16]
	ld.ub	%r13,[%r2]
	ld.w	%r4,%r1
	sub	%r4,%r14
	ld.w	%r14,%r4
	add	%r15,%r12
	ld.w	%r12,%r15
	sll	%r14,0x8	; 	xsll	%r14,8
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX90		; 	xjreq	__L90
	ld.w	%r12,0x1	; 	xld.w	%r12,0x00000001		; 1
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX90:				; __L90:
	ext	0x1		; 	xbtst	[%r2+1],0x3
	btst	[%r2],0x3
	jreq	__LX91		; 	xjreq	__L91
	ext	ppu_draw_bg@rm	; 	xcall	ppu_draw_bg
	call	ppu_draw_bg@rl
__LX91:				; __L91:
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX85		; 	xjreq	__L85
	ld.w	%r12,%r0
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX85:				; __L85:
	ld.w	%r14,%r1
	ext	0xa		; 	xld.b	[%r2+10],%r1
	ld.b	[%r2],%r1
	ext	0x3		; 	xld.w	%r13,0x000000ef		; 239
	ld.w	%r13,0x2f
	cmp	%r1,%r13
	jrgt	__LX93		; 	xjrgt	__L93
	cmp	%r1,0x0
	jrne	__LX94		; 	xjrne	__L94
	ext	0x2		; 	xld.ub	%r10,[%r2+2]
	ld.ub	%r10,[%r2]
	ext	0x0		; 	xand	%r10,%r10,0x0000003f
	and	%r10,0x3f
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
__LX94:				; __L94:
	ext	0x2		; 	xld.ub	%r12,[%r2+2]
	ld.ub	%r12,[%r2]
	ext	0x1		; 	xld.w	%r11,0x00000040		; 64
	ld.w	%r11,0x0
	ld.w	%r10,%r12
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jrne	__LX95		; 	xjrne	__L95
	ext	ppu_sprram+0x0@ah	; 	xld.ub	%r10,[ppu_sprram]
	ext	ppu_sprram+0x0@al
	ld.ub	%r10,[%r8]
	add	%r10,0x1	; 	xadd	%r10,%r10,1
	ld.ub	%r10,%r10
	cmp	%r10,%r13
	jrle	__LX96		; 	xjrle	__L96
	ld.b	%r10,%r10
__LX96:				; __L96:
	cmp	%r1,%r10
	jrge	__LX97		; 	xjrge	__L97
	ld.w	%r1,%r10
	jp	__LX99		; 	xjp	__L99
__LX97:				; __L97:
	ld.w	%r10,%r12
	or	%r10,%r11
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
__LX95:				; __L95:
	ext	0x3		; 	xld.w	%r1,0x000000f0		; 240
	ld.w	%r1,0x30
__LX99:				; __L99:
	ext	0xb		; 	xld.b	[%r2+11],%r1
	ld.b	[%r2],%r1
	jp	__LX100		; 	xjp	__L100
__LX93:				; __L93:
	ext	0x2		; 	xld.w	%r11,0x00000080		; 128
	ld.w	%r11,0x0
	ld.w	%r10,%r11
	ext	0x2		; 	xld.ub	%r4,[%r2+2]
	ld.ub	%r4,[%r2]
	or	%r10,%r4
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
	ld.w	%r10,%r11
	ld.ub	%r4,[%r2]	; 	xld.ub	%r4,[%r2]
	and	%r10,%r4
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jreq	__LX101		; 	xjreq	__L101
	ld.w	%r10,%r11
	ext	0x8		; 	xld.ub	%r4,[%r2+8]
	ld.ub	%r4,[%r2]
	or	%r10,%r4
	ext	0x8		; 	xld.b	[%r2+8],%r10
	ld.b	[%r2],%r10
__LX101:				; __L101:
	ext	0x4		; 	xld.w	%r1,0x00000106		; 262
	ld.w	%r1,0x6
	ld.w	%r4,0x0
	ext	0xb		; 	xld.b	[%r2+11],%r4
	ld.b	[%r2],%r4
__LX100:				; __L100:
	ld.w	%r11,%r1
	sub	%r11,%r14
	ext	0x3		; 	xld.w	%r10,0x000000e4		; 228
	ld.w	%r10,0x24
	mlt.w	%r11,%r10
	ld.w	%r10,%alr
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r2
	ret
	.align	1
	.global	ppu_vram_write
ppu_vram_write:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	0x7f		; 	xcmp	%r12,8191
	cmp	%r12,0x3f
	jrgt	__LX103		; 	xjrgt	__L103
	ld.w	%r10,%r12
	add	%r10,%r11
	jp	__LX117		; 	xjp	__L117
__LX103:				; __L103:
	ext	0xbf		; 	xcmp	%r12,12287
	cmp	%r12,0x3f
	jrgt	__LX105		; 	xjrgt	__L105
	ext	ppu+0x8@ah	; 	xld.ub	%r10,[ppu+8]
	ext	ppu+0x8@al
	ld.ub	%r10,[%r8]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX106		; 	xjreq	__L106
	ld.w	%r10,%r12
	ext	0x1fdf		; 	xand	%r10,%r10,0xfffff7ff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x20		; 	xoor	%r10,%r10,0x00000800
	or	%r10,0x0
	add	%r10,%r11
	jp	__LX117		; 	xjp	__L117
__LX106:				; __L106:
	ld.w	%r10,%r12
	ext	0x1fef		; 	xand	%r10,%r10,0xfffffbff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x10		; 	xoor	%r10,%r10,0x00000400
	or	%r10,0x0
	add	%r10,%r11
	jp	__LX117		; 	xjp	__L117
__LX105:				; __L105:
	ext	0xfb		; 	xcmp	%r12,16127
	cmp	%r12,0x3f
	jrle	__LX104		; 	xjrle	__L104
	ext	0xfc		; 	xcmp	%r12,16143
	cmp	%r12,0xf
	jrgt	__LX111		; 	xjrgt	__L111
	ld.w	%r14,%r12
	add	%r14,%r11
	ld.w	%r11,%r14
	ld.b	[%r11],%r13	; 	xld.b	[%r11],%r13
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	jrne	__LX104		; 	xjrne	__L104
	ext	0x10		; 	xld.b	[%r11+16],%r13
	ld.b	[%r11],%r13
	jp	__LX104		; 	xjp	__L104
__LX111:				; __L111:
	ext	0xfc		; 	xcmp	%r12,16159
	cmp	%r12,0x1f
	jrgt	__LX104		; 	xjrgt	__L104
	ld.w	%r14,%r12
	add	%r14,%r11
	ld.w	%r11,%r14
	ld.b	[%r11],%r13	; 	xld.b	[%r11],%r13
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	jrne	__LX104		; 	xjrne	__L104
	ext	0x10		; 	xsub	%r10,%r11,16
	sub	%r10,%r11
__LX117:				; __L117:
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
__LX104:				; __L104:
	ret
	.align	1
	.global	ppu_draw_bg
ppu_draw_bg:
;	.frame	%sp,52,$31		# vars= 32, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x8		; 	xsub	%sp,%sp,32
	ext	ppu_vram+0x0@h	; 	xld.w	%r7,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r7,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r6,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r6,[%r8]
	ld.w	[%sp+0x0],%r6	; 	xld.w	[%sp],%r6
	ext	ppu+0xb@ah	; 	xld.ub	%r6,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r6,[%r8]
	ld.w	[%sp+0x1],%r6	; 	xld.w	[%sp+4],%r6
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	ld.w	%r11,%r10
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	sll	%r11,0x4	; 	xsll	%r11,4
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	sll	%r10,0x8	; 	xsll	%r10,10
	sll	%r10,0x2
	ld.w	%r2,%r10
	ext	0x80		; 	xoor	%r2,%r2,0x00002000
	or	%r2,0x0
	ext	ppu+0x4@ah	; 	xld.uh	%r3,[ppu+4]
	ext	ppu+0x4@al
	ld.uh	%r3,[%r8]
	ld.ub	%r4,%r3
	sra	%r3,0x8		; 	xsra	%r3,8
	ext	0x3		; 	xcmp	%r4,239
	cmp	%r4,0x2f
	jrle	__LX119		; 	xjrle	__L119
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
	sub	%r4,0x10	; 	xsub	%r4,%r4,16
__LX119:				; __L119:
	ld.w	%r0,%r3
	sra	%r0,0x3		; 	xsra	%r0,3
	ld.w	%r1,%r4
	sra	%r1,0x3		; 	xsra	%r1,3
	ld.w	%r10,%r3
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r3,%r10
	add	%r3,1
	ld.w	%r10,%r4
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r4,%r10
	add	%r4,1
__LX120:				; __L120:
	ld.w	%r10,[%sp+0x0]	; 	xld.w	%r10,[%sp]
	sub	%r10,0x8	; 	xsub	%r10,%r10,8
	cmp	%r4,%r10
	jrle	__LX123		; 	xjrle	__L123
	ext	0x0		; 	xld.w	%r5,0x00000021		; 33
	ld.w	%r5,0x21
	ld.w	%r10,%r1
	and	%r10,0x3c	; 	xand	%r10,%r10,0xfffffffc
	sll	%r10,0x1	; 	xsll	%r10,1
	ext	0xf		; 	xoor	%r10,%r10,0x000003c0
	or	%r10,0x0
	ld.w	[%sp+0x7],%r10	; 	xld.w	[%sp+28],%r10
__LX124:				; __L124:
	ld.w	%r10,%r1
	sll	%r10,0x5	; 	xsll	%r10,5
	ld.w	%r6,%r2
	or	%r6,%r10
	ld.w	%r10,%r6
	or	%r10,%r0
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r14,[%r10]	; 	xld.ub	%r14,[%r10]
	ld.w	%r10,%r2
	ld.w	%r6,[%sp+0x7]	; 	xld.w	%r6,[%sp+28]
	or	%r10,%r6
	ld.w	%r11,%r0
	sra	%r11,0x2	; 	xsra	%r11,2
	or	%r10,%r11
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r15,[%r10]	; 	xld.ub	%r15,[%r10]
	ld.w	%r11,%r0
	and	%r11,0x2	; 	xand	%r11,%r11,0x00000002
	ld.w	%r10,%r1
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	sll	%r10,0x1	; 	xsll	%r10,1
	or	%r11,%r10
	ld.w	%r9,%r11	; 	xsra	%r15,%r11
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sra	%r15,0x8
	jp.d	-3
	sub	%r9,0x8
	sra	%r15,%r9
	ld.w	%r12,%r3
	ld.w	%r13,%r4
	ld.w	%r6,[%sp+0x2]	; 	xld.w	%r6,[%sp+8]
	or	%r14,%r6
	and	%r15,0x3	; 	xand	%r15,%r15,0x00000003
	ld.w	[%sp+0x3],%r4	; 	xld.w	[%sp+12],%r4
	ld.w	[%sp+0x4],%r5	; 	xld.w	[%sp+16],%r5
	ld.w	[%sp+0x6],%r7	; 	xld.w	[%sp+24],%r7
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	add	%r3,0x8		; 	xadd	%r3,%r3,8
	add	%r0,0x1		; 	xadd	%r0,%r0,1
	ld.w	%r4,[%sp+0x3]	; 	xld.w	%r4,[%sp+12]
	ld.w	%r5,[%sp+0x4]	; 	xld.w	%r5,[%sp+16]
	ld.w	%r7,[%sp+0x6]	; 	xld.w	%r7,[%sp+24]
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX126		; 	xjrle	__L126
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX126:				; __L126:
	sub	%r5,0x1		; 	xsub	%r5,%r5,1
	jrne	__LX124		; 	xjrne	__L124
	ext	0x4		; 	xsub	%r3,%r3,264
	sub	%r3,0x8
	add	%r0,0x1f	; 	xadd	%r0,%r0,31
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX123		; 	xjrle	__L123
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX123:				; __L123:
	add	%r4,0x8		; 	xadd	%r4,%r4,8
	add	%r1,0x1		; 	xadd	%r1,%r1,1
	cmp	%r1,0x1d	; 	xcmp	%r1,29
	jrle	__LX122		; 	xjrle	__L122
	sub	%r1,0x1e	; 	xsub	%r1,%r1,30
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
__LX122:				; __L122:
	ld.w	%r6,[%sp+0x1]	; 	xld.w	%r6,[%sp+4]
	cmp	%r4,%r6
	jrlt	__LX120		; 	xjrlt	__L120
	add	%sp,0x8		; 	xadd	%sp,%sp,32
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite
ppu_draw_sprite:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@ah	; 	xbtst	[ppu],0x5
	ext	ppu+0x0@al
	btst	[%r8],0x5
	jreq	__LX133		; 	xjreq	__L133
	call	ppu_draw_sprite_8x16	; 	xcall	ppu_draw_sprite_8x16
	jp	__LX134		; 	xjp	__L134
__LX133:				; __L133:
	call	ppu_draw_sprite_8x8	; 	xcall	ppu_draw_sprite_8x8
__LX134:				; __L134:
	ret
	.align	1
	.global	ppu_draw_sprite_8x8
ppu_draw_sprite_8x8:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r1,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r1,ppu_sprram+0xfc@l
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	ld.w	%r3,%r10
	sll	%r3,0x5		; 	xsll	%r3,5
	ld.w	%r2,%r12
	sll	%r2,0x5		; 	xsll	%r2,5
	ext	0x1		; 	xld.w	%r0,0x00000040		; 64
	ld.w	%r0,0x0
__LX136:				; __L136:
	ld.w	%r12,[%r1]	; 	xld.w	%r12,[%r1]
	sub	%r1,0x4		; 	xsub	%r1,%r1,4
	ld.ub	%r13,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r14,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r11,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r12,%r12
	ld.w	%r10,%r11
	xor	%r10,%r2
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX138		; 	xjrne	__L138
	ext	0x1		; 	xadd	%r10,%r13,1
	add	%r10,%r13
	ld.ub	%r13,%r10
	ext	0x3		; 	xcmp	%r13,239
	cmp	%r13,0x2f
	jrle	__LX140		; 	xjrle	__L140
	ld.b	%r13,%r13
__LX140:				; __L140:
	or	%r14,%r3
	ld.w	%r10,%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r15,%r10
	or	%r15,0x4	; 	xoor	%r15,%r15,0x00000004
	ld.w	%r10,%r11
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX144		; 	xjreq	__L144
	jrgt	__LX147		; 	xjrgt	__L147
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX143		; 	xjreq	__L143
	jp	__LX142		; 	xjp	__L142
__LX147:				; __L147:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX145		; 	xjreq	__L145
__LX142:				; __L142:
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX138		; 	xjp	__L138
__LX143:				; __L143:
	ext	ppu_draw_chr_revx@rm	; 	xcall	ppu_draw_chr_revx
	call	ppu_draw_chr_revx@rl
	jp	__LX138		; 	xjp	__L138
__LX144:				; __L144:
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX138		; 	xjp	__L138
__LX145:				; __L145:
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX138:				; __L138:
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX136		; 	xjrne	__L136
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite_8x16
ppu_draw_sprite_8x16:
;	.frame	%sp,32,$31		# vars= 12, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x3		; 	xsub	%sp,%sp,12
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r4,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r4,ppu_sprram+0xfc@l
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	sll	%r12,0x5	; 	xsll	%r12,5
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ext	0x1		; 	xld.w	%r4,0x00000040		; 64
	ld.w	%r4,0x0
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
__LX150:				; __L150:
	ld.w	%r4,[%sp+0x1]	; 	xld.w	%r4,[%sp+4]
	ld.w	%r0,[%r4]	; 	xld.w	%r0,[%r4]
	sub	%r4,0x4		; 	xsub	%r4,%r4,4
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	ld.ub	%r2,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r1,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r12,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r0,%r0
	ld.w	%r10,%r12
	ld.w	%r4,[%sp+0x0]	; 	xld.w	%r4,[%sp]
	xor	%r10,%r4
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX152		; 	xjrne	__L152
	add	%r2,0x1		; 	xadd	%r2,%r2,1
	ld.w	%r10,%r1
	and	%r10,0x3e	; 	xand	%r10,%r10,0xfffffffe
	ld.w	%r11,%r1
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	sll	%r11,0x8	; 	xsll	%r11,8
	ld.w	%r1,%r10
	or	%r1,%r11
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r3,%r10
	or	%r3,0x4		; 	xoor	%r3,%r3,0x00000004
	ld.w	%r10,%r12
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX157		; 	xjreq	__L157
	jrgt	__LX160		; 	xjrgt	__L160
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX156		; 	xjreq	__L156
	jp	__LX155		; 	xjp	__L155
__LX160:				; __L160:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX158		; 	xjreq	__L158
__LX155:				; __L155:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX152		; 	xjp	__L152
__LX156:				; __L156:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	call	ppu_draw_chr_revx	; 	xcall	ppu_draw_chr_revx
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	call	ppu_draw_chr_revx	; 	xcall	ppu_draw_chr_revx
	jp	__LX152		; 	xjp	__L152
__LX157:				; __L157:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX152		; 	xjp	__L152
__LX158:				; __L158:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX152:				; __L152:
	ld.w	%r4,[%sp+0x2]	; 	xld.w	%r4,[%sp+8]
	sub	%r4,0x1		; 	xsub	%r4,%r4,1
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
	jrne	__LX150		; 	xjrne	__L150
	add	%sp,0x3		; 	xadd	%sp,%sp,12
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revx
ppu_draw_chr_revx:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX162		; 	xjrle	__L162
	cmp	%r13,%r1
	jrge	__LX162		; 	xjrge	__L162
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX162		; 	xjrugt	__L162
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX165		; 	xjrlt	__L165
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX165		; 	xjrgt	__L165
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX165		; 	xjrugt	__L165
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX166:				; __L166:
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX169:				; __L169:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX172		; 	xjreq	__L172
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX172:				; __L172:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX169		; 	xjrne	__L169
	add	%r5,%r12
	add	%r6,0x1		; 	xadd	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX166		; 	xjrne	__L166
	jp	__LX162		; 	xjp	__L162
__LX165:				; __L165:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX176:				; __L176:
	cmp	%r13,%r2
	jrlt	__LX179		; 	xjrlt	__L179
	cmp	%r13,%r1
	jrge	__LX179		; 	xjrge	__L179
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX180:				; __L180:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX183		; 	xjreq	__L183
	cmp	%r12,%r3
	jrugt	__LX183		; 	xjrugt	__L183
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX183:				; __L183:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX180		; 	xjrne	__L180
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX179:				; __L179:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	add	%r6,0x1		; 	xadd	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX176		; 	xjrne	__L176
__LX162:				; __L162:
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revy
ppu_draw_chr_revy:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX187		; 	xjrle	__L187
	cmp	%r13,%r1
	jrge	__LX187		; 	xjrge	__L187
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX187		; 	xjrugt	__L187
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	or	%r10,0x7	; 	xoor	%r10,%r10,0x00000007
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX190		; 	xjrlt	__L190
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX190		; 	xjrgt	__L190
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX190		; 	xjrugt	__L190
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX191:				; __L191:
	ld.ub	%r10,[%r6]	; 	xld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r4,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r4,[%r9]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r10,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX194:				; __L194:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX197		; 	xjreq	__L197
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX197:				; __L197:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX194		; 	xjrne	__L194
	add	%r5,%r12
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX191		; 	xjrne	__L191
	jp	__LX187		; 	xjp	__L187
__LX190:				; __L190:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX201:				; __L201:
	cmp	%r13,%r2
	jrlt	__LX204		; 	xjrlt	__L204
	cmp	%r13,%r1
	jrge	__LX204		; 	xjrge	__L204
	ld.ub	%r10,[%r6]	; 	xld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r4,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r4,[%r9]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r10,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX205:				; __L205:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX208		; 	xjreq	__L208
	cmp	%r12,%r3
	jrugt	__LX208		; 	xjrugt	__L208
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX208:				; __L208:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX205		; 	xjrne	__L205
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX204:				; __L204:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX201		; 	xjrne	__L201
__LX187:				; __L187:
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revxy
ppu_draw_chr_revxy:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX212		; 	xjrle	__L212
	cmp	%r13,%r1
	jrge	__LX212		; 	xjrge	__L212
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX212		; 	xjrugt	__L212
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	or	%r10,0x7	; 	xoor	%r10,%r10,0x00000007
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX215		; 	xjrlt	__L215
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX215		; 	xjrgt	__L215
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX215		; 	xjrugt	__L215
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX216:				; __L216:
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX219:				; __L219:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX222		; 	xjreq	__L222
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX222:				; __L222:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX219		; 	xjrne	__L219
	add	%r5,%r12
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX216		; 	xjrne	__L216
	jp	__LX212		; 	xjp	__L212
__LX215:				; __L215:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX226:				; __L226:
	cmp	%r13,%r2
	jrlt	__LX229		; 	xjrlt	__L229
	cmp	%r13,%r1
	jrge	__LX229		; 	xjrge	__L229
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX230:				; __L230:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX233		; 	xjreq	__L233
	cmp	%r12,%r3
	jrugt	__LX233		; 	xjrugt	__L233
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX233:				; __L233:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX230		; 	xjrne	__L230
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX229:				; __L229:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX226		; 	xjrne	__L226
__LX212:				; __L212:
	popn	%r3
	ret

	.comm	ppu 48

	.comm	ppu_vram 16384

	.comm	ppu_sprram 256

