/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ene04.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/11
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemy04Int(ACT* actp);

void
actEnemy04(ACT* actp)
{
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY;
		actp->col[X] = fld(3 *  9);
		actp->col[Y] = fld(2 * 16);
		actp->energy = 4;
		actp->int_adr = actEnemy04Int;
		if(fcom(actp->pos[X], <, fld(320.0))) {
			actp->vel[X] = fld(+2.0);
			actp->trg[X] = fld(-3.0);
		} else {
			actp->vel[X] = fld(-2.0);
			actp->trg[X] = fld(+3.0);
		}
		actp->vel[Y] = fld(6.0);
		actp->trg[Y] = fld(6.0);
		actp->cnt = 30;
		BulletMLaddCtrl(actp, 3);
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		fadd_(actp->pos[X], actp->vel[X]);
		fadd_(actp->pos[Y], actp->vel[Y]);
		fsub_(actp->vel[X], fidiv(actp->vel[X], 60));
		fsub_(actp->vel[Y], fidiv(actp->vel[Y], 60));
		/* e */
		BulletMLexecCtrl(actp);
		/* \ */
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 3 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) - 2 * 16 / 2;
		DrawString(pos[X], pos[Y], "TYT", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "| |", color);
		if(actp->cnt) {
			actp->cnt--;
		} else {
			ACTnextStep();
		}
		break;
	case 2:
		/* ړ */
		fadd_(actp->pos[X], actp->vel[X]);
		fadd_(actp->pos[Y], actp->vel[Y]);
		fadd_(actp->vel[X], fidiv(fsub(actp->trg[X], actp->vel[X]), 60));
		fadd_(actp->vel[Y], fidiv(fsub(actp->trg[Y], actp->vel[Y]), 60));
		if(fcom(actp->pos[Y], >, fld(480.0+16.0))) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* e */
		BulletMLexecCtrl(actp);
		/* \ */
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 3 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) - 2 * 16 / 2;
		DrawString(pos[X], pos[Y], "TYT", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "| |", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		enemy_cnt--;
		break;
	}
}

static void
actEnemy04Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			soundPlaySe(SE_EXP01);
			ACTexitStep();
			score += 1;
			actEnemyChkDest();
		}
	}
}

