/*==========================================================================
 *
 *  Copyright (C) 2002 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:sound.c
 *  Content	:TEh֘A
 *  Program	:J.Issiki
 *  Date	:2002/1/27
 *  UpDate	:2003/12/12
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

typedef struct _SND {
	const char* fname;
	int ch;
	const void* data;
} SND;
static SND snd_tbl[SND_COUNT] = {
	{ "se_correct.ppd",	1 },	/*  */
	{ "se_select.ppd",	1 },	/* I */
	{ "se_bomb.ppd",	2 },	/* { */
	{ "se_power.ppd",	1 },	/* p[Abv */
	{ "se_getbomb.ppd",	1 },	/* {擾 */
	{ "se_dmg01.ppd",	3 },	/* {X_[W */
	{ "se_career.ppd",	1 },	/* LAj */
	{ "se_exp01.ppd",	3 },	/* G */
	{ "se_exp02.ppd",	2 },	/* {X */
	{ "se_exp03.ppd",	2 },	/* @ */
	{ "se_extend.ppd",	1 },	/* GNXeh */
	//
	{ "bgm_vax11.ppd",	0 },	/* bgm */
};

void
soundInitBuffer()
{
	int i;
	const void* fpk;

	fpk = resource_address(PEX_FNAME);
	for(i = 0; i < SND_COUNT; i++) {
		snd_tbl[i].data = fpk_address(fpk, snd_tbl[i].fname, NULL);
	}
}

void
soundPlayBgm(int num)
{
	SND* snd = &snd_tbl[BGM_VAX11];
	sound_play(snd->ch, snd->data, -1);
}

void
soundStopBgm()
{
	SND* snd = &snd_tbl[BGM_VAX11];
	sound_stop(snd->ch);
}

void
soundPlaySe(int num)
{
	SND* snd = &snd_tbl[num];
	sound_play(snd->ch, snd->data, 1);
}

