/*==========================================================================
 *
 *  Copyright (C) 2001 Jumpie Isshiki. All Rights Reserved.
 *
 *  File	:start.cpp
 *  Content	:WindowsX^[gAbv
 *  Program	:J.Issiki
 *  Date	:2001/6/24
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void BulletMLInit();
static void ClsDrawScreen();
static void GetKeyData();

void
app_main()
{
	/* TEh */
	soundInitBuffer();

	/* BulletMLǂݍ */
	BulletMLInit();

	/* ANg */
	ACTinit();
	ACTsetBtm(actMain, GROUP_00);

	/* C[v */
	for(;;) {
		schedule();
		ClsDrawScreen();

		/* L[͎擾 */
		GetKeyData();

		/* I */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* ANgs */
		ACTexec();

		/* RW`FbN */
		CollisionCheck();

		frame++;
	}
}

static void
BulletMLInit()
{
	static const unsigned char* const tbl[BULLETML_MAX] = {
		"enemy01.xml",
		"enemy02.xml",
		"enemy03.xml",
		"enemy04.xml",
		"enemy05.xml",
		"enemy06.xml",
		"enemy07.xml",
		"enemy08.xml",
		"boss0101.xml",
		"boss0102.xml",
		"boss0201.xml",
		"boss0202.xml",
	};
	int i;
	int y = 4;
	const void* fpk;
	const char* xml;
	char* buf;
	int size;

	render_printf(&render, (4* 1), y, 0x82, 0, "INIT BULLETML"); update(); y += 6;
	fpk = resource_address(PEX_FNAME);
	for(i = 0; i < BULLETML_MAX; i++) {
		render_printf(&render, (4* 1), y, 0x82, 0, "LOAD %s", tbl[i]); update();
		xml = fpk_address(fpk, tbl[i], &size);
		buf = calloc(size + 1/*nul*/, 1); /* \[XXMLeLXgnulI[ĂȂ̂ŁAꎞobt@ɃRs[nulI[܂ */
		if(!buf) DIE();
		memcpy(buf, xml, size);
		BulletMLreadFiles(i, buf);
		free(buf);
		render_printf(&render, (4*19), y, 0x82, 0, "OK"); update(); y += 6;
	}

	{
		/* BulletMLBullet/BulletMLActionv[ɂȂăq[vւ̕ԋpA̂h߂ɁA
		 * _~[BulletMLBullet/BulletMLAction𐶐ĂA΂Ƀv[ɂȂȂ悤ɂ܂B
		 */
		ACT* actp = calloc(1, sizeof(ACT));
		BulletMLaddCtrl(actp, 0);
		free(actp);
	}
}

static void
ClsDrawScreen()
{
	memset(vbuff + DISP_X*4, 3, DISP_X*(DISP_Y-8));
}

static void
GetKeyData()
{
	KEYdat = 0;
	if(joy & PAD_DN) KEYdat |= PAD_INPUT_DOWN;
	if(joy & PAD_LF) KEYdat |= PAD_INPUT_LEFT;
	if(joy & PAD_RI) KEYdat |= PAD_INPUT_RIGHT;
	if(joy & PAD_UP) KEYdat |= PAD_INPUT_UP;
	if(joy & PAD_A ) KEYdat |= PAD_INPUT_A;
	if(joy & PAD_B ) KEYdat |= PAD_INPUT_B;

	KEYtrg = 0;
	if(joy & TRG_DN) KEYtrg |= PAD_INPUT_DOWN;
	if(joy & TRG_LF) KEYtrg |= PAD_INPUT_LEFT;
	if(joy & TRG_RI) KEYtrg |= PAD_INPUT_RIGHT;
	if(joy & TRG_UP) KEYtrg |= PAD_INPUT_UP;
	if(joy & TRG_A ) KEYtrg |= PAD_INPUT_A;
	if(joy & TRG_B ) KEYtrg |= PAD_INPUT_B;
}

